/*  LINALG.H                                                      */

#if !defined LINALGDEF
#define LINALGDEF

#if !defined MAXDIM
   #define MAXDIM 23000
#endif
#if !defined MINIDIM
   #define MINIDIM 25
#endif

#include "ints.h"

#define UNITSPERROW (1 + (MAXDIM >> UNSIZE))

typedef struct {
   unit dat[UNITSPERROW];
} row;

typedef struct {
   unsigned num_r,num_c,units_per_row;
   unit dat[MAXDIM][UNITSPERROW];
} matrix;

typedef struct {
   unsigned num_r,num_c,units_per_row;
   unit dat[MINIDIM][UNITSPERROW];
} minimatrix;

void dok(unit *p, int n);  
void dokmat(matrix *m);
void dokminimat(minimatrix *m);
void add_row(unit *p, unit *q, unsigned k);
void copy_row(unit *p, unit *q, unsigned k);
void clear_row(unit *p, unsigned k);
void clear_matrix(matrix *m, unsigned z, unsigned s);
void unit_matrix(matrix *m, unsigned z);
void matrix_copy(matrix *m, matrix *n);
void kernel_basis(matrix *m, matrix *n);
void quotient_basis(matrix *m, matrix *n, minimatrix *r);
int lift(minimatrix *m1, matrix *M, minimatrix *res);
int set_values(matrix *m, unsigned z, unsigned s);
int matrix_is_zero(matrix *m);

#endif
