/* random.c  --  a random collection of functions that probably belong */
/*               somewhere else                                        */

#include "random.h"

int alpha(unit n) {
  int res = 0;
  for (;n;n &= n-1,res++) ;
  return res;
}

int alpha_vector(unit *dat, modinfo *mi) {
  int res = 0;
  int n = mi->totdim;
  n >>= UNSIZE; n++;
  while (n--) res += alpha(dat[n]);
  return res;
}

int new_stoplist_from_vector(stoplist *st, unit *dat, modinfo *mi) {
   /* WARNING: clears profile */
   /* returns number of summands */
   stop s,x; unit u; int h; int t=mi->tdegree; int n;
   int res = 0, dm = 0; int res2;
   stop *o;
   res2 = alpha_vector(dat,mi); /* number of summands */
   malloc_stoplist(st,res2);    /* memory allocated   */
   o = st->dat;
   set_empty_profile(); 
   clear_stop(&x);
   u = 1; h = 0;
   for (n=0;n<mi->mod->numgens;n++) {
      int dg = mi->mod->gens[n].deg;
      if (dg > t) break;
      dg = t-dg; s.id = n;
      {
         if (first_stop(&s,degrees,dg))
            do {
               dm++;
               if (0 != (dat[h] & u)) {
                  copy_stop(o,&s); 
		  res++; o++;
               }
               u <<= 1; if (0 == u) { u = 1; h++; };
            } while (next_stop(&s,degrees));
      }
   }
   if (dm != mi->totdim) {
      printf("random.c: totdim = %d, found %d\n",mi->totdim,dm);
      /*for (dm=0;dm<20;dm++) printf("dim(%d) = %d\n",dm,dim(dm));*/
      error("work this out!");
   }
   if (res != res2) error("internal error in new_stoplist_from_vector");
   return res;
}

void extract_diff(unit *res, element *e, unit *dat, modinfo *mi) {
   unit u; int h; int n = e->num,m;

   for (u=1,h=0,m=0;n--;) {
      int x = module_seqno(&(e->dat[m]),mi); unit z = 1;
      z <<= (x & UNMASK);
      if (0 != (dat[x >> UNSIZE] & z)) res[h] ^= u;
      m++; u <<= 1; if (!u) { u = 1; h++; };
   }
	MMXCLEAR;
}

void add_diff(unit *(res[]), int num, minimatrix *mat, element *bas, module *ms, modinfo *mi, int deg) {
   /*  For  k = 1...num:                                 */
   /*  add  d(mat.dat[k])  to  res[k]                    */
   /*  the vector  mat.dat[k]  refers to the basis  bas, */
   /*              res[k]      refers to modinfo  mi     */
   unit *(dt[MINIDIM+1]);  /* pointers to results */
   unit u; int h; 
   int dim = bas->num;   
   int k,l,m; unit **aux;
   for (u=1,h=0,k=0;k<dim;k++) {
      aux = dt;
      for (m=l=0;l<num;l++) {
         if (0 != (mat->dat[l][h] & u)) {
            *aux++ = res[l]; m++;
         }
      }
      if (m) {   /* found something */
         stoplist *diff = &(ms->gens[bas->dat[k].id].diff);    
         *aux = NULL; /* mark end of result */
         optimized_multiply(&(bas->dat[k]),diff,dt,mi,deg);
      }
      if (0 == (u <<= 1)) { u = 1; h++; }
   }
	MMXCLEAR;
}

void add_basis_vector_to_module_vector(unit *bvec, element *bs, 
				       unit *mvec, modinfo *mi) {
  unit ub,uv; int hb,hv; int n;
  ub = 1; hb = 0; 
  for (n=0;n<bs->num;n++) {
    if (0 != (bvec[hb] & ub)) {
      int s;
      s = module_seqno(&(bs->dat[n]),mi);
		MMXCLEAR;
      uv = 1; hv = s; hv >>= UNSIZE; uv <<= (s & UNMASK);
      mvec[hv] ^= uv;
    }
    if (!(ub <<= 1)) { ub = 1; hb++; }
  }
}

